<?php

namespace Treewec\Utils;

/**
 * Test class for Instances.
 * Generated by PHPUnit on 2012-03-25 at 16:24:10.
 * @group utils
 */
class InstancesTest extends \PHPUnit_Framework_TestCase {

    public function testIsInstanceOf() {
        parent::assertTrue(Instances::isInstanceOf(new \Exception(), '\Exception'));
        $this->assertException(new \Exception(), '\Treewec\Controller');
    }

    public function testIsClassConstant() {
        $reflection = new \ReflectionClass('\Treewec\HTML\Listing');
        foreach ($reflection->getConstants() as $constant => $value) {
            parent::assertTrue(Instances::isClassConstant('\Treewec\HTML\Listing', $constant));
        }
        parent::assertFalse(Instances::isClassConstant('\Treewec\HTML\Listing', 'helloWorld'));
        parent::assertFalse(Instances::isClassConstant('class', null));
        parent::assertFalse(Instances::isClassConstant(null, 'class'));
    }

    private function assertException($object, $class) {        
        try {
            call_user_func(array('\Treewec\Utils\Instances', 'isInstanceOf'), $object, $class);
            $this->failTest('exception was not thrown');
        } catch (\Exception $e) {
            $this->caughtException = $e;
            parent::assertInstanceOf('\Treewec\Exceptions\InstanceException', $e);
        }
    }

}

?>
